local addonName, TF = ...

local TradeFill = LibStub("AceAddon-3.0"):GetAddon(addonName)

function TradeFill:SearchInventory()
    TF.inventory = {}

    for key = 1, MAX_TRADABLE_ITEMS do
        local item = TradeFill.db.profile.item[tostring(key)]

        if item.id > 0 then
            TF.stackCount[key] = { id = item.id, trade = 0 }
        else
            TF.stackCount[key] = { id = 0, trade = 0 }
        end
    end

    for bag = 0, 4 do
        for slot = 1, C_Container.GetContainerNumSlots(bag) do
            local bagItem = C_Container.GetContainerItemInfo(bag, slot)

            if bagItem ~= nil then
                for key = 1, MAX_TRADABLE_ITEMS do
                    if bagItem.itemID == TF.item[tostring(key)].id then
                        table.insert(TF.inventory, {
                            ["bag"] = bag,
                            ["slot"] = slot,
                            ["itemID"] = bagItem.itemID,
                            ["itemName"] = bagItem.itemName,
                            ["bound"] = bagItem.isBound,
                            ["count"] = bagItem.stackCount,
                            ["link"] = bagItem.hyperlink
                        })
                    end
                end
            end
        end
    end
end