local addonName, TF = ...

local TradeFill = LibStub("AceAddon-3.0"):GetAddon(addonName)
local Loc = LibStub("AceLocale-3.0"):GetLocale(addonName)

local Minimap = LibStub("LibDBIcon-1.0", true)

function Minimap:InitializeMinimapButton(self)
    TF.icon = LibStub("LibDataBroker-1.1"):NewDataObject("minimap", Minimap:DefaultsMinimap())
    Minimap:Register("minimap", TF.icon, self.db.profile.minimap)


    if TradeFill.db.profile.setting.auto then
        Minimap:SetButtonOn()
    else
        Minimap:SetButtonOff()
    end
end

function Minimap:DefaultsMinimap()
    return
    {
        type = "data source",
        text = "minimap",
        icon = "",
        OnTooltipShow = function(tooltip)
            tooltip:SetText("|c8788EEff" .. addonName .. "|r")
            tooltip:AddLine(Minimap:SetTooltipLeftClick(Loc["MINIMAP_LEFT_CLICK_ENABLE"]))
            tooltip:AddLine(Minimap:SetTooltipRightClick(Loc["MINIMAP_RIGHT_CLICK_OPEN"]))
            tooltip:AddLine((Loc["MINIMAP_SHIFT_CLICK_REFRESH"]))
            tooltip:Show()
        end,
        OnClick = function(_, click )
            if IsShiftKeyDown() and click == "LeftButton" then
                TradeFill.limit:ResetProfile()

                DEFAULT_CHAT_FRAME:AddMessage(TF.signature .. Loc["REMOVED_LIMIT"])
            elseif click == "LeftButton" then
                if TradeFill.db.profile.setting.auto then
                    TradeFill:Off()
                    Minimap:SetButtonOff()
                else
                    TradeFill:On()
                    Minimap:SetButtonOn()
                end
            end

            if click == "RightButton" then
                if SettingsPanel:IsShown() then
                    HideUIPanel(SettingsPanel)
                    HideUIPanel(GameMenuFrame)
                else
                    TradeFill:SlashCommand()
                end
            end
        end
    }
end

function Minimap:SetTooltipLeftClick()
    local text = Loc["MINIMAP_LEFT_CLICK_ENABLE"]

    if TradeFill.db.profile.setting.auto then
        text = Loc["MINIMAP_LEFT_CLICK_DISABLE"]
    end
    return text
end

function Minimap:SetTooltipRightClick()
    local text = Loc["MINIMAP_RIGHT_CLICK_OPEN"]

    if SettingsPanel:IsShown() then
        text = Loc["MINIMAP_RIGHT_CLICK_CLOSE"]
    end
    return text
end

function Minimap:SetButtonOn()
    TF.icon.icon = "Interface\\AddOns\\"..addonName.."\\images\\Spell_Nature_Polymorph_Cow.tga"
end

function Minimap:SetButtonOff()
    TF.icon.icon = "Interface\\AddOns\\"..addonName.."\\images\\Spell_Nature_Polymorph_Cow_Red.tga"
end